package xhttp3.internal.platform;

import java.lang.reflect.InvocationHandler;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.lang.reflect.Proxy;
import java.util.List;
import javax.net.ssl.SSLSocket;
import xhttp3.Protocol;
import xhttp3.internal.Util;

class JdkWithJettyBootPlatform extends Platform {
   private final Method putMethod;
   private final Method getMethod;
   private final Method removeMethod;
   private final Class<?> clientProviderClass;
   private final Class<?> serverProviderClass;

   public JdkWithJettyBootPlatform(Method putMethod, Method getMethod, Method removeMethod, Class<?> clientProviderClass, Class<?> serverProviderClass) {
      this.putMethod = putMethod;
      this.getMethod = getMethod;
      this.removeMethod = removeMethod;
      this.clientProviderClass = clientProviderClass;
      this.serverProviderClass = serverProviderClass;
   }

   public static Platform buildIfSupported() {
      String var0 = "org.eclipse.jetty.alpn.ALPN";
      String var10000 = "org.eclipse.jetty.alpn.ALPN";

      boolean var10001;
      Class var10002;
      StringBuilder var10003;
      Class var33;
      Class var35;
      try {
         var33 = Class.forName(var10000);
         var35 = var33;
         var10002 = var33;
         var10003 = new StringBuilder;
      } catch (ClassNotFoundException var29) {
         var10001 = false;
         return null;
      } catch (NoSuchMethodException var30) {
         var10001 = false;
         return null;
      }

      StringBuilder var10004 = var10003;

      Class var39;
      try {
         var10004.<init>();
         var39 = Class.forName(var10003.append(var0).append("$Provider").toString());
      } catch (ClassNotFoundException var27) {
         var10001 = false;
         return null;
      } catch (NoSuchMethodException var28) {
         var10001 = false;
         return null;
      }

      Class var1 = var39;

      try {
         var10003 = new StringBuilder;
      } catch (ClassNotFoundException var25) {
         var10001 = false;
         return null;
      } catch (NoSuchMethodException var26) {
         var10001 = false;
         return null;
      }

      var10004 = var10003;

      try {
         var10004.<init>();
         var39 = Class.forName(var10003.append(var0).append("$ClientProvider").toString());
      } catch (ClassNotFoundException var23) {
         var10001 = false;
         return null;
      } catch (NoSuchMethodException var24) {
         var10001 = false;
         return null;
      }

      Class var2 = var39;

      try {
         var10003 = new StringBuilder;
      } catch (ClassNotFoundException var21) {
         var10001 = false;
         return null;
      } catch (NoSuchMethodException var22) {
         var10001 = false;
         return null;
      }

      var10004 = var10003;

      try {
         var10004.<init>();
         var39 = Class.forName(var10003.append(var0).append("$ServerProvider").toString());
      } catch (ClassNotFoundException var19) {
         var10001 = false;
         return null;
      } catch (NoSuchMethodException var20) {
         var10001 = false;
         return null;
      }

      Class var31 = var39;
      String var40 = "put";

      Class[] var41;
      try {
         var41 = new Class[2];
      } catch (ClassNotFoundException var17) {
         var10001 = false;
         return null;
      } catch (NoSuchMethodException var18) {
         var10001 = false;
         return null;
      }

      Class[] var10005 = var41;
      Class[] var10006 = var41;
      byte var10007 = 0;

      Method var36;
      try {
         var10006[var10007] = SSLSocket.class;
         var10005[1] = var1;
         var36 = var10002.getMethod(var40, var41);
      } catch (ClassNotFoundException var15) {
         var10001 = false;
         return null;
      } catch (NoSuchMethodException var16) {
         var10001 = false;
         return null;
      }

      Method var32 = var36;
      String var37 = "get";

      Class[] var42;
      try {
         var42 = new Class[1];
      } catch (ClassNotFoundException var13) {
         var10001 = false;
         return null;
      } catch (NoSuchMethodException var14) {
         var10001 = false;
         return null;
      }

      var41 = var42;
      byte var43 = 0;

      Method var45;
      try {
         var41[var43] = SSLSocket.class;
         var45 = var35.getMethod(var37, var42);
      } catch (ClassNotFoundException var11) {
         var10001 = false;
         return null;
      } catch (NoSuchMethodException var12) {
         var10001 = false;
         return null;
      }

      Method var3 = var45;
      String var46 = "remove";

      Class[] var38;
      try {
         var38 = new Class[1];
      } catch (ClassNotFoundException var9) {
         var10001 = false;
         return null;
      } catch (NoSuchMethodException var10) {
         var10001 = false;
         return null;
      }

      var42 = var38;
      byte var44 = 0;

      Method var34;
      try {
         var42[var44] = SSLSocket.class;
         var34 = var33.getMethod(var46, var38);
      } catch (ClassNotFoundException var7) {
         var10001 = false;
         return null;
      } catch (NoSuchMethodException var8) {
         var10001 = false;
         return null;
      }

      Method var4 = var34;

      try {
         return new JdkWithJettyBootPlatform(var32, var3, var4, var2, var31);
      } catch (ClassNotFoundException var5) {
         var10001 = false;
      } catch (NoSuchMethodException var6) {
         var10001 = false;
      }

      return null;
   }

   public void configureTlsExtensions(SSLSocket sslSocket, String hostname, List<Protocol> protocols) {
      JdkWithJettyBootPlatform var10000 = this;
      List hostname1 = Platform.alpnProtocolNames(protocols);

      Object var15;
      InvocationTargetException var18;
      label74: {
         IllegalAccessException var17;
         label66: {
            boolean var10001;
            Class[] var10002;
            ClassLoader var19;
            try {
               var19 = Platform.class.getClassLoader();
               var10002 = new Class[2];
            } catch (InvocationTargetException var12) {
               var18 = var12;
               var10001 = false;
               break label74;
            } catch (IllegalAccessException var13) {
               var17 = var13;
               var10001 = false;
               break label66;
            }

            Class[] var10003 = var10002;
            Class[] var10005 = var10002;
            JdkWithJettyBootPlatform var10004 = this;
            JdkWithJettyBootPlatform var10006 = this;
            byte var14 = 0;

            try {
               var10005[var14] = var10006.clientProviderClass;
            } catch (InvocationTargetException var10) {
               var18 = var10;
               var10001 = false;
               break label74;
            } catch (IllegalAccessException var11) {
               var17 = var11;
               var10001 = false;
               break label66;
            }

            var14 = 1;

            Object var21;
            try {
               var10003[var14] = var10004.serverProviderClass;
               var21 = Proxy.newProxyInstance(var19, var10002, new JettyNegoProvider(hostname1));
            } catch (InvocationTargetException var8) {
               var18 = var8;
               var10001 = false;
               break label74;
            } catch (IllegalAccessException var9) {
               var17 = var9;
               var10001 = false;
               break label66;
            }

            var15 = var21;

            Method var20;
            try {
               var20 = var10000.putMethod;
            } catch (InvocationTargetException var6) {
               var18 = var6;
               var10001 = false;
               break label74;
            } catch (IllegalAccessException var7) {
               var17 = var7;
               var10001 = false;
               break label66;
            }

            var19 = null;

            try {
               var20.invoke(var19, sslSocket, var15);
               return;
            } catch (InvocationTargetException var4) {
               var18 = var4;
               var10001 = false;
               break label74;
            } catch (IllegalAccessException var5) {
               var17 = var5;
               var10001 = false;
            }
         }

         var15 = var17;
         throw new AssertionError(var15);
      }

      var15 = var18;
      throw new AssertionError(var15);
   }

   public void afterHandshake(SSLSocket param1) {
      // $FF: Couldn't be decompiled
   }

   public String getSelectedProtocol(SSLSocket socket) {
      Method var10000;
      boolean var10001;
      try {
         var10000 = this.getMethod;
      } catch (InvocationTargetException var14) {
         var10001 = false;
         throw new AssertionError();
      } catch (IllegalAccessException var15) {
         var10001 = false;
         throw new AssertionError();
      }

      Object var21 = null;

      JettyNegoProvider var18;
      try {
         var18 = (JettyNegoProvider)Proxy.getInvocationHandler(var10000.invoke(var21, socket));
      } catch (InvocationTargetException var12) {
         var10001 = false;
         throw new AssertionError();
      } catch (IllegalAccessException var13) {
         var10001 = false;
         throw new AssertionError();
      }

      JettyNegoProvider var16 = var18;

      boolean var19;
      try {
         var19 = var18.unsupported;
      } catch (InvocationTargetException var10) {
         var10001 = false;
         throw new AssertionError();
      } catch (IllegalAccessException var11) {
         var10001 = false;
         throw new AssertionError();
      }

      String var20;
      if (!var19) {
         try {
            var20 = var16.selected;
         } catch (InvocationTargetException var8) {
            var10001 = false;
            throw new AssertionError();
         } catch (IllegalAccessException var9) {
            var10001 = false;
            throw new AssertionError();
         }

         if (var20 == null) {
            try {
               Platform.get().log(4, "ALPN callback dropped: SPDY and HTTP/2 are disabled. Is alpn-boot on the boot class path?", (Throwable)null);
               return null;
            } catch (InvocationTargetException var2) {
               var10001 = false;
               throw new AssertionError();
            } catch (IllegalAccessException var3) {
               var10001 = false;
               throw new AssertionError();
            }
         }
      }

      try {
         var19 = var16.unsupported;
      } catch (InvocationTargetException var6) {
         var10001 = false;
         throw new AssertionError();
      } catch (IllegalAccessException var7) {
         var10001 = false;
         throw new AssertionError();
      }

      String var17;
      if (var19) {
         var17 = null;
         return var17;
      } else {
         try {
            var20 = var16.selected;
         } catch (InvocationTargetException var4) {
            var10001 = false;
            throw new AssertionError();
         } catch (IllegalAccessException var5) {
            var10001 = false;
            throw new AssertionError();
         }

         var17 = var20;
         return var17;
      }
   }

   private static class JettyNegoProvider implements InvocationHandler {
      private final List<String> protocols;
      private boolean unsupported;
      private String selected;

      public JettyNegoProvider(List<String> protocols) {
         this.protocols = protocols;
      }

      public Object invoke(Object proxy, Method method, Object[] args) {
         String proxy1 = method.getName();
         Class var4 = method.getReturnType();
         if (args == null) {
            args = Util.EMPTY_STRING_ARRAY;
         }

         if (proxy1.equals("supports") && Boolean.TYPE == var4) {
            return Boolean.TRUE;
         } else if (proxy1.equals("unsupported") && Void.TYPE == var4) {
            this.unsupported = true;
            return null;
         } else if (proxy1.equals("protocols") && ((Object[])args).length == 0) {
            return this.protocols;
         } else if ((proxy1.equals("selectProtocol") || proxy1.equals("select")) && String.class == var4 && ((Object[])args).length == 1 && ((Object[])args)[0] instanceof List) {
            List proxy2;
            List var10000 = proxy2 = (List)((Object[])args)[0];
            int method1 = 0;

            for(int args1 = var10000.size(); method1 < args1; ++method1) {
               if (this.protocols.contains(proxy2.get(method1))) {
                  return this.selected = (String)proxy2.get(method1);
               }
            }

            return this.selected = (String)this.protocols.get(0);
         } else if ((proxy1.equals("protocolSelected") || proxy1.equals("selected")) && ((Object[])args).length == 1) {
            this.selected = (String)((Object[])args)[0];
            return null;
         } else {
            return method.invoke(this, (Object[])args);
         }
      }
   }
}
